package net.eusashead.hateoas.header.impl;

/*
 * #[license]
 * spring-responseentitybuilder
 * %%
 * Copyright (C) 2013 Eusa's Head
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * %[license]
 */

import net.eusashead.hateoas.header.CacheControlHeader;

public class CacheControlHeaderImpl implements CacheControlHeader {

	public static final String CACHE_CONTROL_HEADER = "Cache-Control";
	
	private final String value;
	
	public CacheControlHeaderImpl(Long maxAge) {
		StringBuilder builder = new StringBuilder();
		builder.append("public, ");
		builder.append("must-revalidate, ");
		builder.append("proxy-revalidate, ");
		builder.append(String.format("max-age=%d", maxAge/1000));
		this.value = builder.toString();
	}
	
	@Override
	public String getName() {
		return CACHE_CONTROL_HEADER;
	}

	@Override
	public String getValue() {
		return this.value;
	}

}
