package net.eusashead.hateoas.header.impl;

/*
 * #[license]
 * spring-responseentitybuilder
 * %%
 * Copyright (C) 2013 Eusa's Head
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * %[license]
 */

import java.beans.PropertyDescriptor;

import org.apache.commons.beanutils.ConvertUtils;
import org.springframework.beans.BeanUtils;

public class PropertyUtil {

	public static Object getValue(Object target, String name) {
		PropertyDescriptor property = BeanUtils.getPropertyDescriptor(target.getClass(), name); 
		try {
			return property.getReadMethod().invoke(target);
		} catch (Exception e) {
			throw new RuntimeException("Unable to get value for target " + target.getClass());
		} 
	}
	
	public static <V> V getValue(Object target, String name, Class<V> type) {
		return type.cast(ConvertUtils.convert(getValue(target, name), type));
	}
	
}
