package net.eusashead.hateoas.response;

/*
 * #[license]
 * spring-responseentitybuilder
 * %%
 * Copyright (C) 2013 Eusa's Head
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * %[license]
 */

import org.springframework.http.HttpMethod;

/**
 * Sends an OPTIONS response
 * with Allow header and
 * an optional body. The body
 * would contain documentation
 * describing the possible operations
 * for the given resource.
 * 
 * @author patrickvk
 *
 */
public interface OptionsResponseBuilder<T> extends ResponseBuilder<T> {
	
	/**
	 * Set the wrapped entity
	 * that this response represents
	 * @param entity
	 */
	OptionsResponseBuilder<T> entity(T entity);
	
	/** 
	 * Add the supplied methods
	 * to the Allow header
	 * 
	 * @param methods
	 */
	OptionsResponseBuilder<T> allow(HttpMethod... methods);

}
